grails-app/domain/homeautomation/Device.groovy
package homeautomation

class Device {
    String name
    String description
	boolean mode = false

    static hasMany=[logs:Log]
    static constraints={
        name(nullable:false)
        description(blank:true,nullable:true)
        mode(nullable:false)
    }
    static belongsTo=[venue:Venue]
}

grails-app/controllers/homeautomation/DeviceController.groovy
package homeautomation

import static org.springframework.http.HttpStatus.*
import grails.transaction.Transactional
import homeautomation.Venue
import homeautomation.Log

@Transactional(readOnly = true)
class DeviceController {
    def deviceService

    static allowedMethods = [save: "POST", update: "PUT", delete: "DELETE"]

    def index(Integer max) {
        params.max = Math.min(max ?: 10, 100)
        respond Device.list(params), model:[deviceCount: Device.count()]
    }

    def show(Device device) {
        println(params)
        respond device
    }

    def create() {
        println(params)
        respond new Device(params)
    }

    @Transactional
    def save(Device device) {
        println(params)
        if (device == null) {
            transactionStatus.setRollbackOnly()
            notFound()
            return
        }

        deviceService.saveDevice(device,params)

        if (device.hasErrors()) {
            transactionStatus.setRollbackOnly()
            respond device.errors, view:'create'
            return
        }

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.created.message', args: [message(code: 'device.label', default: 'Device'), device.id])
                redirect device
            }
            '*' { respond device, [status: CREATED] }
        }
    }

    def edit(Device device) {
        respond device
    }

    @Transactional
    def update(Device device) {
        println("params at device/update"+params)
        if (device == null) {
            transactionStatus.setRollbackOnly()
            notFound()
            return
        }

        if (device.hasErrors()) {
            transactionStatus.setRollbackOnly()
            respond device.errors, view:'edit'
            return
        }
        deviceService.updateDevice(device,params)

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.updated.message', args: [message(code: 'device.label', default: 'Device'), device.id])
                redirect device
            }
            '*'{ respond device, [status: OK] }
        }
    }

    @Transactional
    def delete(Device device) {

        if (device == null) {
            transactionStatus.setRollbackOnly()
            notFound()
            return
        }

        device.delete flush:true

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.deleted.message', args: [message(code: 'device.label', default: 'Device'), device.id])
                redirect action:"index", method:"GET"
            }
            '*'{ render status: NO_CONTENT }
        }
    }

    protected void notFound() {
        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.not.found.message', args: [message(code: 'device.label', default: 'Device'), params.id])
                redirect action: "index", method: "GET"
            }
            '*'{ render status: NOT_FOUND }
        }
    }
}

grails-app/views/device/create.gsp
<!DOCTYPE html>
<%@page import="homeautomation.Venue" %>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'device.label', default: 'Device')}" />
        <title><g:message code="default.create.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#create-device" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>
        <div id="create-device" class="content scaffold-create" role="main">
            <h1><g:message code="default.create.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
            </g:if>
            <g:hasErrors bean="${this.device}">
            <ul class="errors" role="alert">
                <g:eachError bean="${this.device}" var="error">
                <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message error="${error}"/></li>
                </g:eachError>
            </ul>
            </g:hasErrors>


            <g:form action="save">
                <fieldset class="form">

                    <ul class="property-list">
                        <li class="fieldcontain">
                        <label>Name</label>
                        <span class="required-indicator">*</span>
                        <g:field type="text" name="deviceName" required="" />
                        </li>

                        <li class="fieldcontain">
                        <label >Description</label>
                        &nbsp;&nbsp;
                        <g:field type="text" name="deviceDescription" />
                        </li>

                        <li class="fieldcontain">
                        <label>Venue</label>
                        <span class="required-indicator">*</span>
                        <g:select optionKey="id" optionValue="name" name="venue" from="${Venue.findAll()}" />
                        </li>
                    </ul>
                </fieldset>
                <fieldset class="buttons">
                    <g:submitButton name="create" class="save" value="${message(code: 'default.button.create.label', default: 'Create')}" />
                </fieldset>
            </g:form>
        </div>
    </body>
</html>

grails-app/views/device/edit.gsp
<!DOCTYPE html>
<%@page import="homeautomation.Venue" %>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'device.label', default: 'Device')}" />
        <title><g:message code="default.edit.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#edit-device" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
                <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>
        <div id="edit-device" class="content scaffold-edit" role="main">
            <h1><g:message code="default.edit.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
            </g:if>
            <g:hasErrors bean="${this.device}">
            <ul class="errors" role="alert">
                <g:eachError bean="${this.device}" var="error">
                <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message error="${error}"/></li>
                </g:eachError>
            </ul>
            </g:hasErrors>
            <g:form resource="${this.device}" method="PUT">
                <g:hiddenField name="version" value="${this.device?.version}" />
                <fieldset class="form">
                    

                    <ul class="property-list">
                        <li class="fieldcontain">
                        <label>Name</label>
                        <span class="required-indicator">*</span>
                        <g:field type="text" name="deviceName" required="" value="${device?.name}"/>
                        </li>

                        <li class="fieldcontain">
                        <label >Address</label>
                        &nbsp;&nbsp;
                        <g:field type="text" name="deviceDescription" value="${device?.description}" />
                        </li>

                        <li class="fieldcontain">
                        <label >Mode(On/Off)</label>
                        <span class="required-indicator">*</span>
                        <g:checkBox name="deviceSwitch" checked="${device.mode}" style="clear:right; padding-right:260px;"/>

                        </li>

                        <li class="fieldcontain">
                        <label>Venue</label>
                        <span class="required-indicator">*</span>
                        <g:select optionKey="id" optionValue="name" name="venue" from="${Venue.findAll()}" />
                        </li>
                    </ul>



                </fieldset>
                <fieldset class="buttons">
                    <input class="save" type="submit" value="${message(code: 'default.button.update.label', default: 'Update')}" />
                </fieldset>
            </g:form>
        </div>
    </body>
</html>

grails-app/views/device/index.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'device.label', default: 'Device')}" />
        <title><g:message code="default.list.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#list-device" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>
        <div id="list-device" class="content scaffold-list" role="main">
            <h1><g:message code="default.list.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
                <div class="message" role="status">${flash.message}</div>
            </g:if>

             <table>
                            <thead>
                                <tr>
                                    <th>Name</th>
                                    <th>Description</th>
                                    <th>Venue</th>
                                    <th>Mode</th>
                                </tr>
                            </thead>
                            <tbody>
                            <g:each var="device" in="${deviceList}">
                                <tr>
                                    <td>
                                    <g:link controller="device" action="show" id="${device.id}">
                                    ${device.name}</g:link>
                                    </td>
                                    <td>${device.description}</td>
                                    <td>${device.venue.name}</td>
                                    <td><g:if test="${device.mode==false}">Off</g:if>
                                    <g:else>On</g:else>
                                    </td>
                                    
                                </tr>
                            </g:each>


                            </tbody>
                        </table>


            <div class="pagination">
                <g:paginate total="${deviceCount ?: 0}" />
            </div>
        </div>
    </body>
</html>

grails-app/views/device/show.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'device.label', default: 'Device')}" />
        <title><g:message code="default.show.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#show-device" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
                <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>
        <div id="show-device" class="content scaffold-show" role="main">
            <h1>device Details</h1>
            <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
            </g:if>
            <ul class="property-list">
                <li class="fieldcontain">
                    <span id="name" class="name" style="clear:right; padding-right:300px;" >
                    <g:message message="Name"/></span>
                    <span class="name-value" aria-labelledby="name"><g:fieldValue bean="${device}" field="name"></g:fieldValue>
                    </span>
                </li>

                <f:display bean="device" property="description"/>

                <li class="fieldcontain">
                    <span id="venue" class="venue" style="clear:right; padding-right:300px;" >
                    <g:message message="Venue"/></span>
                    <span class="venue-value" aria-labelledby="venue">
                    <g:link controller="venue" action="show" params="[venueId:device.venue.id]">
                        ${device.venue.name}</g:link>
                    </span>
                </li>

                <li class="fieldcontain">
                    <span id="mode" class="mode" style="clear:right; padding-right:300px;" >
                    <g:message message="Mode"/></span>
                    <span class="mode-value" aria-labelledby="mode">

                    <label style="font-weight:normal; text-align:left;">
                        <g:if test="${device.mode}">On</g:if>
                        <g:else>Off</g:else>
                    </label>

                    </span>
                </li>

                <f:display bean="device" property="logs"/>
            </ul>

            <g:form resource="${this.device}" method="DELETE">
                <fieldset class="buttons">
                    <g:link class="edit" action="edit" resource="${this.device}"><g:message code="default.button.edit.label" default="Edit" /></g:link>
                    <input class="delete" type="submit" value="${message(code: 'default.button.delete.label', default: 'Delete')}" onclick="return confirm('${message(code: 'default.button.delete.confirm.message', default: 'Are you sure?')}');" />
                </fieldset>
            </g:form>
        </div>
    </body>
</html>